from abc import ABC, abstractmethod

import numpy as np


class Layer:

    @property
    @abstractmethod
    def tileWidth(self) -> int:
        raise NotImplementedError()

    @property
    @abstractmethod
    def tileHeight(self) -> int:
        raise NotImplementedError()

    @property
    @abstractmethod
    def textureWidth(self) -> int:
        raise NotImplementedError()

    @property
    @abstractmethod
    def textureHeight(self) -> int:
        raise NotImplementedError()

    @abstractmethod
    def setTexture(self, fileName: str, tileWidth: int, tileHeight: int):
        raise NotImplementedError()

    @abstractmethod
    def setGridMesh(self, grid: np.ndarray):
        raise NotImplementedError()
